/*
 * Copyright (C) Vladimir Oleynik <dzo@simtreas.ru> 2015-2023
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
*/

#include "opt_gen.h"
BITS_GEN(BIT, FOUND, COUNT_CMP_L, COUNT_CMP_G, ICONV_OK, CMD_IS_COMPLEX,
IGNORE_CASE, IS_LOOP, H_MOD, IS_LABEL, IS_RTEST, ADD_REPL, INS_REPL,
FAST_REPL, INPUT_STORED, ADD_HEAD, SAVE_FLAGS, IS_PK, HAVE_UNUSED, REGEX,
DYN_REGEX, CC_P_MOD)
#include "opt_gen.h"

#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <stdint.h>

#include "regex.h"

#define CODE_UNUSED             245
#define CODE_FIND_STATUS        246
#define CODE_UPPER              247
#define CODE_LOWER              248
#define CODE_INPUT_FILE         249
#define CODE_COUNT              250
#define CODE_INB                251
#define CODE_OUT                252
#define CODE_BUF2               253
#define CODE_HEAD               254
#define CODE_END                255


struct REPLACES {
	void *find;
	regex_t *R;
	size_t lf;
	size_t *offs;
	size_t n_offs;
	unsigned char *codes;
	char opt;
	unsigned int mods;
	size_t line;
	struct REPLACES *next;
};

/* libbb */
extern const char *prg_name;

extern char process_escape_sequence(const char **ptr);
extern void error_msg(int errc, const char *s, ...) __attribute__ ((noreturn, format (printf, 2, 3)));
extern void *xmalloc(size_t sz);
extern void *xrealloc(void *b, size_t sz);
extern void *xcalloc(size_t n, size_t sz);

/* utf8 */
extern unsigned char used[256];

extern int up_low(const char *b, size_t bl, int flg_up_low, char *out, size_t need_convert, int chg_internally);
extern size_t calc_up_low(const char *b, size_t bl, int flg_up_low, size_t *need_convert);
extern void test_is_utf8(void);
extern size_t mbchar_len (const char *s, size_t l);
extern long mbchar_code (const char *s, size_t l);
extern long iconv_buf(char *ft, size_t line, char **pout, size_t *psz);

static inline size_t utf8_skip_len(unsigned char c)
{
  const uint64_t MULT= 270549121;
  uint64_t magic = (c >> 2) * MULT + 272696336;
  magic = (((magic >> 6) & MULT)*MULT) >> 28;
  return 1 + (magic & 7);
}
