/*
 * The majority of the magic tricks used in this file are based on those
 * described by Paul Fultz II (c) 2015 in his "Cloak" library:
 *
 *    https://github.com/pfultz2/Cloak/wiki/C-Preprocessor-tricks,-tips,-and-idioms
 *
*/

/* for 1...64 calls */
#ifndef BITS_GEN

#define EVAL(...) EVAL32(__VA_ARGS__)
#define EVAL32(...) EVAL16(EVAL16(__VA_ARGS__))
#define EVAL16(...) EVAL8(EVAL8(__VA_ARGS__))
#define EVAL8(...) EVAL4(EVAL4(__VA_ARGS__))
#define EVAL4(...) EVAL2(EVAL2(__VA_ARGS__))
#define EVAL2(...) EVAL1(EVAL1(__VA_ARGS__))
#define EVAL1(...) __VA_ARGS__

#define FIRST(a, ...) a
#define SECOND(a, b, ...) b
#define EMPTY()
#define DEFER2(m) m EMPTY EMPTY()()

#define IS_PROBE(...) SECOND(__VA_ARGS__, 0)
#define PROBE() ~, 1

#define CAT(a,b) a ## b

#define NOT(x) IS_PROBE(CAT(_NOT_, x))
#define _NOT_0 PROBE()

#define BOOL(x) NOT(NOT(x))

#define IF_ELSE(c) _IF_ELSE(BOOL(c))
#define _IF_ELSE(c) CAT(_IFE_, c)
#define _IFE_1(...) __VA_ARGS__ _IF_0
#define _IFE_0(...)             _IF_1

#define IF(c) _IF(BOOL(c))
#define _IF(c) CAT(_IF_,c)
#define _IF_0(...)
#define _IF_1(...) __VA_ARGS__

#define HAS_ARGS(...) BOOL(FIRST(_END_OF_ARGUMENTS_ __VA_ARGS__)())
#define _END_OF_ARGUMENTS_() 0


#define INC(x) CAT(INC_,x)
#define INC_0 1
#define INC_1 2
#define INC_2 3
#define INC_3 4
#define INC_4 5
#define INC_5 6
#define INC_6 7
#define INC_7 8
#define INC_8 9
#define INC_9 10
#define INC_10 11
#define INC_11 12
#define INC_12 13
#define INC_13 14
#define INC_14 15
#define INC_15 16
#define INC_16 17
#define INC_17 18
#define INC_18 19
#define INC_19 20
#define INC_20 21
#define INC_21 22
#define INC_22 23
#define INC_23 24
#define INC_24 25
#define INC_25 26
#define INC_26 27
#define INC_27 28
#define INC_28 29
#define INC_29 30
#define INC_30 31
#define INC_31 32
#define INC_32 33
#define INC_33 34
#define INC_34 35
#define INC_35 36
#define INC_36 37
#define INC_37 38
#define INC_38 39
#define INC_39 40
#define INC_40 41
#define INC_41 42
#define INC_42 43
#define INC_43 44
#define INC_44 45
#define INC_45 46
#define INC_46 47
#define INC_47 48
#define INC_48 49
#define INC_49 50
#define INC_50 51
#define INC_51 52
#define INC_52 53
#define INC_53 54
#define INC_54 55
#define INC_55 56
#define INC_56 57
#define INC_57 58
#define INC_58 59
#define INC_59 60
#define INC_60 61
#define INC_61 62
#define INC_62 63
#define INC_63 64

#define BITS_GEN_MAP0(count, name, ...) \
  name = 1<<count \
  IF(HAS_ARGS(__VA_ARGS__))(, DEFER2(_BITS_GEN_MAP0)()(INC(count), __VA_ARGS__))

#define _BITS_GEN_MAP0() BITS_GEN_MAP0

#define BITS_GEN0(first, ...) \
enum first { first = 0, EVAL(BITS_GEN_MAP0(0, __VA_ARGS__)) };

#define BITS_GEN_MAP(count, pref, name, ...)              \
  CAT(pref,name) = 1<<count                  \
  IF(HAS_ARGS(__VA_ARGS__))(, DEFER2(_BITS_GEN_MAP)()(INC(count), pref, __VA_ARGS__))

#define _BITS_GEN_MAP() BITS_GEN_MAP

#define BITS_GEN(first, ...) \
enum CAT(first,_BITS) { first = 0, EVAL(BITS_GEN_MAP(0, CAT(first,_), __VA_ARGS__)) };

#else

#undef EVAL
#undef EVAL32
#undef EVAL16
#undef EVAL8
#undef EVAL4
#undef EVAL2
#undef EVAL1

#undef FIRST
#undef SECOND
#undef EMPTY
#undef DEFER2
#undef FIRST
#undef SECOND
#undef EMPTY
#undef DEFER2
#undef IS_PROBE
#undef PROBE
#undef CAT
#undef NOT
#undef _NOT_0
#undef BOOL
#undef IF_ELSE
#undef _IF_ELSE
#undef _IFE_1
#undef _IFE_0
#undef IF
#undef _IF
#undef _IF_0
#undef _IF_1
#undef HAS_ARGS
#undef _END_OF_ARGUMENTS_
#undef INC
#undef INC_0
#undef INC_1
#undef INC_2
#undef INC_3
#undef INC_4
#undef INC_5
#undef INC_6
#undef INC_7
#undef INC_8
#undef INC_9
#undef INC_10
#undef INC_11
#undef INC_12
#undef INC_13
#undef INC_14
#undef INC_15
#undef INC_16
#undef INC_17
#undef INC_18
#undef INC_19
#undef INC_20
#undef INC_21
#undef INC_22
#undef INC_23
#undef INC_24
#undef INC_25
#undef INC_26
#undef INC_27
#undef INC_28
#undef INC_29
#undef INC_30
#undef INC_31
#undef INC_32
#undef INC_33
#undef INC_34
#undef INC_35
#undef INC_36
#undef INC_37
#undef INC_38
#undef INC_39
#undef INC_40
#undef INC_41
#undef INC_42
#undef INC_43
#undef INC_44
#undef INC_45
#undef INC_46
#undef INC_47
#undef INC_48
#undef INC_49
#undef INC_50
#undef INC_51
#undef INC_52
#undef INC_53
#undef INC_54
#undef INC_55
#undef INC_56
#undef INC_57
#undef INC_58
#undef INC_59
#undef INC_60
#undef INC_61
#undef INC_62
#undef INC_63

#undef BITS_GEN
#endif
